from datetime import datetime
from typing import List, Optional, Dict, Any

from janis_core import *
from janis_core.types.common_data_types import Boolean, Int, String, File

Flye_Samtools_Markdup_V0_1_0 = CommandToolBuilder(tool="flye_samtools_markdup", base_command=["flye-samtools", "markdup"], inputs=[ToolInput(tag="in_remove_duplicate_reads", input_type=Boolean(optional=True), prefix="-r", doc=InputDocumentation(doc="Remove duplicate reads")), ToolInput(tag="in_max_read_bases", input_type=Int(optional=True), prefix="-l", doc=InputDocumentation(doc="Max read length (default 300 bases)")), ToolInput(tag="in_mark_supplemenary_alignments", input_type=Boolean(optional=True), prefix="-S", doc=InputDocumentation(doc="Mark supplemenary alignments of duplicates as duplicates (slower).")), ToolInput(tag="in_report_stats", input_type=Boolean(optional=True), prefix="-s", doc=InputDocumentation(doc="Report stats.")), ToolInput(tag="in_write_temporary_files", input_type=String(optional=True), prefix="-T", doc=InputDocumentation(doc="Write temporary files to PREFIX.samtools.nnnn.nnnn.tmp.")), ToolInput(tag="in_mark_primary_duplicates", input_type=Boolean(optional=True), prefix="-t", doc=InputDocumentation(doc="Mark primary duplicates with the name of the original in a 'do' tag. Mainly for information and debugging.")), ToolInput(tag="in_input_fmt_option", input_type=File(optional=True), prefix="--input-fmt-option", doc=InputDocumentation(doc="[=VAL]\nSpecify a single input file format option in the form\nof OPTION or OPTION=VALUE")), ToolInput(tag="in_output_fmt", input_type=String(optional=True), prefix="--output-fmt", doc=InputDocumentation(doc="[,OPT[=VAL]]...\nSpecify output format (SAM, BAM, CRAM)")), ToolInput(tag="in_output_fmt_option", input_type=File(optional=True), prefix="--output-fmt-option", doc=InputDocumentation(doc="[=VAL]\nSpecify a single output file format option in the form\nof OPTION or OPTION=VALUE")), ToolInput(tag="in_reference", input_type=File(optional=True), prefix="--reference", doc=InputDocumentation(doc="Reference sequence FASTA FILE [null]")), ToolInput(tag="in_threads", input_type=Int(optional=True), prefix="--threads", doc=InputDocumentation(doc="Number of additional threads to use [0]")), ToolInput(tag="in_sam_tools", input_type=String(), position=0, doc=InputDocumentation(doc="")), ToolInput(tag="in_mark_dup", input_type=String(), position=1, doc=InputDocumentation(doc="")), ToolInput(tag="in_input_dot_bam", input_type=String(), position=2, doc=InputDocumentation(doc="")), ToolInput(tag="in_output_dot_bam", input_type=String(), position=3, doc=InputDocumentation(doc=""))], outputs=[ToolOutput(tag="out_output_fmt_option", output_type=File(optional=True), selector=InputSelector(input_to_select="in_output_fmt_option", type_hint=File()), doc=OutputDocumentation(doc="[=VAL]\nSpecify a single output file format option in the form\nof OPTION or OPTION=VALUE"))], container="quay.io/biocontainers/flye:2.8.3--py38h1c8e9b9_0", version="v0.1.0")


if __name__ == "__main__":
    # or "cwl"
    Flye_Samtools_Markdup_V0_1_0().translate("wdl")

